**********************************************************
* Fecha de modificacin: Agosto 12 de 2000
*
* Crear un grfico en Ms Graph 8.0  con Fox y Ole
* 
* Se pretende Seleccionar:
*     1. El color para el titulo de los ejes x,y.
*     2. El color para el rtulo de datos.
*     3. El color para ajustar el color interior de cada serie del conjunto
*
*  Con este ejemplo se busca dar mas creatividad a todos los foxeros para mejorar
*  las presentaciones de los grficos y permitir al usuario que configure sus titulos,
*  tamaos, fuentes, colores o seleccionar el tipo de grafico que desee.
*
*  Espero les sirva como ejemplo
*
*  Este codigo es una modificacin de uno que aparecia en la revista de *  Foxpress (Espaa) 
*
*
**********************************************************

public Grafico, TxtColorTitulos, TxtColorRotulos, TxtColorInterior

TxtColorTitulos=16711680 && Color para los titulos por defecto (Azul)
TxtColorRotulos=255 && Color para los titulos por defecto (Rojo)
TxtColorInterior=65408  && Color para los titulos por defecto (Verde)

Grafico = CREATEOBJECT('Form')  && Crea un formulario.
Grafico.caption="Grficos con Fox y MS Graph 8.0"
Grafico.height=160
Grafico.width=290
Grafico.AutoCenter=.t.

Grafico.AddObject('CmdColorTitulos','CmdColorTitulos')  && Botn Color.
Grafico.AddObject('CmdColorRotulos','CmdColorRotulos')  && Botn Rtulos.
Grafico.AddObject('CmdColorInterior','CmdColorInterior')  && Botn Interior.
Grafico.AddObject('CmdGraficar','CmdGraficar')  && Botn Graficar.

Grafico.CmdColorTitulos.Visible =.T.  && Botn Color visible.
Grafico.CmdColorRotulos.Visible =.T.  && Botn Color visible.
Grafico.CmdColorInterior.Visible =.T.  && Botn Color visible.
Grafico.CmdGraficar.Visible =.T.  && Botn Grafico visible.

Grafico.SHOW  && Muestra el formulario.
*READ EVENTS  && Inicia el procesamiento de eventos.

DEFINE CLASS CmdColorTitulos AS COMMANDBUTTON  && Crea un botn de comando.
   Caption = 'Color Titulos...'  && Ttulo del botn de comando.
   Left = 50  && Columna del botn de comando.
   Top = 25  && Fila del botn de comando.
   Height = 25  && Alto del botn de comando.
   width=190    && Ancho del botn de comando.
   ForeColor=RGB(0,0,255)  && Color Azul
   
   PROCEDURE Click
    TxtColorTitulos=getcolor()
    tnColor=_Col2RGB(TxtColorTitulos)
    Thisform.CmdColorTitulos.Caption = 'Color Titulos...'+Tncolor  && Modificar Ttulo del botn de comando.
    Thisform.CmdColorTitulos.forecolor=&Tncolor
ENDDEFINE

DEFINE CLASS CmdColorRotulos AS COMMANDBUTTON  && Crea un botn de comando.
   Caption = 'Color Rotulos... '  && Ttulo del botn de comando.
   Left = 50  && Columna del botn de comando.
   Top = 60  && Fila del botn de comando.
   Height = 25  && Alto del botn de comando.
   width=190    && Ancho del botn de comando.
   ForeColor=RGB(255,0,0)  && Color Rojo
   
   PROCEDURE Click
    TxtColorRotulos=getcolor()
    tnColor=_Col2RGB(TxtColorRotulos)
    Thisform.CmdColorRotulos.Caption = 'Color Rotulosr...'+Tncolor  && Modificar Ttulo del botn de comando.
    Thisform.CmdColorRotulos.forecolor=&Tncolor
ENDDEFINE

DEFINE CLASS CmdColorInterior AS COMMANDBUTTON  && Crea un botn de comando.
   Caption = 'Color Interior...'  && Ttulo del botn de comando.
   Left = 50  && Columna del botn de comando.
   Top = 90  && Fila del botn de comando.
   Height = 25  && Alto del botn de comando.
   width=190    && Ancho del botn de comando.
   ForeColor=RGB(0,255,0) && Color Verde
 
   PROCEDURE Click
    TxtColorInterior=getcolor()
    tnColor=_Col2RGB(TxtColorInterior)
    Thisform.CmdColorInterior.Caption = 'Color Interior...'+Tncolor  && Modificar Ttulo del botn de comando.
    Thisform.CmdColorInterior.forecolor=&Tncolor
    Thisform.CmdColorInterior.refresh 
ENDDEFINE


DEFINE CLASS CmdGraficar AS COMMANDBUTTON  && Crea un botn de comando.
   Caption = 'Procesar Grafico...'  && Ttulo del botn de comando.
   Left = 50  && Columna del botn de comando.
   Top = 120  && Fila del botn de comando.
   Height = 25  && Alto del botn de comando.
   width=190    && Ancho del botn de comando.
   picture="C:\graficos\Bmp\nubes.bmp"

   PROCEDURE Click
    Wait windows "Espere por favor mientras procesa el grfico" nowait
    x=Time()
    public pantalla
    pantalla = createobject("form")
    pantalla.height=400
    pantalla.width=700
    Pantalla.Caption="Grafico Ms Graph 8.0"
    Pantalla.Autocenter=.t.
 
    pantalla.addobject("objeto", "olecontrol", "msgraph.chart.8")

    pantalla.objeto.top = 0
    pantalla.objeto.left = 0
    pantalla.objeto.height = pantalla.height
    pantalla.objeto.width = pantalla.width
    pantalla.visible = .t.
    pantalla.objeto.visible = .t.

    pantalla.lockscreen = .t.

    ** Definir el tipo de grafico -4100 es xl3DColumn
    pantalla.objeto.object.application.chart.charttype = -4100

    ** Definir las series que posee el grafico (en este caso una serie)
    pantalla.objeto.object.application.datasheet.range("00").value = ""
    pantalla.objeto.object.application.datasheet.range("01").value = "Ventas"

    ** Llevar valores para la columna A
    pantalla.objeto.object.application.datasheet.range("A0").value = "Enero"
    pantalla.objeto.object.application.datasheet.range("A1").value = 24

    ** Llevar valores para la columna B
    pantalla.objeto.object.application.datasheet.range("B0").value = "Febrero"
    pantalla.objeto.object.application.datasheet.range("B1").value = 48

    ** Borrar las filas que estn llenas por defecto por el graph y no se van a utilizar
    ** si usted trabaja con 3 o ms series no debe hacer lo siguiente.
    pantalla.objeto.object.application.datasheet.rows("4").delete
    pantalla.objeto.object.application.datasheet.rows("3").delete

    ** Borrar las columnas que estn llenas por defecto por el graph y no se van a utilizar
    ** si usted trabaja con 4 o ms columnas no debe hacer lo siguiente.
    pantalla.objeto.object.application.datasheet.columns("5").delete
    pantalla.objeto.object.application.datasheet.columns("4").delete

    ** Cambiar el titulo del grafico
    pantalla.objeto.object.application.chart.hastitle = .t.
    pantalla.objeto.object.application.chart.charttitle.text = "Ventas Bimestre"

    ** Permite Modificar el color de las series con el color verde.
    pantalla.objeto.SeriesCollection(1).Interior.Color = TxtColorInterior && Seleccionado en le form.

    ** Lo siguiente activa el rtulo de datos del primer punto de la serie uno (1) del grfico, 
    ** y establece el texto del rtulo de datos.
    With pantalla.objeto
        With .SeriesCollection(1).Points(1)
             .HasDataLabel = .t.
             .DataLabel.Text = 24 && Valor de la columna A1.
             .DataLabel.Font.color = TxtColorRotulos && Seleccionado en le form.
        EndWith
    EndWith

    ** Lo siguiente activa el rtulo de datos del segundo punto de la serie uno (1) del grfico, 
    ** y establece el texto del rtulo de datos.
    With pantalla.objeto
        With .SeriesCollection(1).Points(2)
             .HasDataLabel = .t.
             .DataLabel.Text = 44 && Valor de la columna B1
             .DataLabel.Font.color = TxtColorRotulos && && Seleccionado en le form
        EndWith
    EndWith

    ** Modificar titulo, tamao, color y fuente del eje X.
    With pantalla.objeto.Axes(1)
        .HasTitle = .t.
        With .AxisTitle
             .Caption = "Meses"
             .Font.Name = "bookman"  
             .Font.Size = 20
            .Font.color = TxtColorTitulos && Color seleccionado en el form
        EndWith
    EndWith

    ** Modificar titulo, tamao, color y fuente del eje Y.
    With pantalla.objeto.Axes(2)
        .HasTitle = .t.
        With .AxisTitle
             .Caption = "Miles Pesos"
             .Font.Name = "bookman"  
             .Font.Size = 20
             .Font.color = TxtColorTitulos && Color seleccionado en el form.
        EndWith
    EndWith

    pantalla.lockscreen = .f.
    Wait windows "Proceso terminado" nowait

ENDDEFINE


*------------------------------------------------
FUNCTION _Col2RGB(tnColor)    
*------------------------------------------------
* Pasa un nmero de color a formato RGB.
* USO: _Col2RGB(1547)
* RETORNA: Caracter - "RGB(nR, nG, nB)"
*------------------------------------------------
  LOCAL lcRGB, ln
  lcRGB="RGB("
  FOR ln=1 TO 3
    lcRGB=lcRGB+TRAN(tnColor%256,"999")+IIF(ln=3, "", ",")
    tnColor=INT(tnColor/256)
  ENDFOR
  lcRGB=lcRGB+")"
  RETURN lcRGB
ENDFUNC


*****************    www.davphantom.4t.com  ******************
*                www3.gratisweb.com/davphantom
*                     DAVID AMADOR TAPIA
**************************************************************
